clear all

global xmin xmax tmin tmax diffusion convection absorption force
global initialdata bctype kl kr gl gr res spres globerr tol

disp('This program solves the diffusion-convection-absorption equation')
disp(' ')
disp('    du/dt - D(dDu) + cDu + au = f      (D=d/dx)')
disp(' ')
disp('in the domain  [xmin,xmax],')
disp('with boundary conditions')
disp(' ')
disp('     dDu + ku = g   or   u = g')
disp(' ')
disp('at  x = xmin  and  x = xmax,  respectively,')
disp('and initial condition')
disp(' ')
disp('      u = v  at time  t = tmin.')
disp(' ')
disp('The solution is computed up to time  tmax,')
disp('with L2  norm error at most  stabfact*tol')
disp('at time  tmax.')
%
%data input
%
xmin=input('xmin = ');
xmax=input('xmax = ');
%
diffusion=input('d(x,t,u) = ','s');
convection=input('c(x,t,u) = ','s');
absorption=input('a(x,t,u) = ','s');
force=input('f(x,t,u) = ','s');
%
kl='0';kr='0';
input('B.c. type at  x = a,  n (Neuman/Robin) or d (Dirichlet) ? ','s');
if ans=='d'; bctype(1)=0; else; bctype(1)=1; end
if bctype(1)==1; kl=input('k(t) = ','s'); end
gl=input('g(t) = ','s');
input('B.c. type at  x = b,  n or d ? ','s');
if ans=='d'; bctype(2)=0; else; bctype(2)=1; end
if bctype(2)==1; kr=input('k(t) = ','s'); end
gr=input('g(t) = ','s');
%
tmin=input('tmin = ');
tmax=input('tmax = ');
%
initialdata=input('v(x) = ','s')
%
tol=input('tol = ');
%
disp('Is the exact solution known?  y  or  n ? ')
exactflag=input('','s');
if exactflag=='y'; uexact=input('u(x,t) = ','s'); end
%
newproblem='y';
problem_type='ibvp';

ibvp_solver
