disp('solve')
global xmin xmax tmin tmax diffusion convection absorption force
global initialdata bctype kl kr gl gr res spres globerr tol
%
if newproblem=='y'
close
figure('Position',[500 40 620 850])
else
clg
figure(gcf);
set(gcf,'Position',[500 40 620 850])
end
newproblem='n';
%
subplot(324);hold off;
plot([xmin xmin xmax xmax],[tmax*1.05 tmin tmin tmax*1.05]);title('mesh');
hold on;title('spacetime mesh')
%
subplot(326);hold off;plot([tmin tmin tmax*1.05],[0.1 0 0]);
hold on; title('time step')
%
DT=(tmax-tmin)/20;
T=tmin+DT/2;
DX=(xmax-xmin)/20;
X=xmin+DX/2:DX:xmax-DX/2;
mesh2=xmin:DX:xmax;
clear US;
US=[];
%
t=tmin;
ni=1200;nn=ni+1;
xold=[xmin:(xmax-xmin)/ni:xmax];
clear uold
for i=1:nn
x=xold(i);
uold(i)=eval(initialdata);
end
if bctype(1)==0;uold(1)=eval(gl);end
if bctype(2)==0;uold(nn)=eval(gr);end
res=diff(uold)./diff(xold);
res=[res(1) (res(1:ni-1)+res(2:ni))/2 res(ni)];
res=abs(diff(res)./diff(xold));
spres=res;
xold=timecorr(xold);
nn=length(xold);
xcold=xold;
for i=1:nn
x=xold(i);
uold(i)=eval(initialdata);
end
dtold=tol;
globerr(2)=tol/2;
%
while t<tmax
disp(['time = ' num2str(t)])
[x,xc,u,dt]=timestep(xold,xcold,uold,t,dtold);
%
nn=length(x);
%
while t<=T&T<t+dt
w1=(T-t)/dt;w2=(t+dt-T)/dt;mesh1=w2*x+w1*xc;
USadd=project(mesh1,u,mesh2);
US=[US;USadd];
T=T+DT;
size(US);
if ans(1)>1
subplot(322);surf(X,[tmin+DT/2:DT:tmin-DT/2+ans(1)*DT],US);
figure(2);surf(X,[tmin+DT/2:DT:tmin-DT/2+ans(1)*DT],US);figure(1)
view(150,20);title('spacetime solution')
end
end
%
subplot(326);plot([t t t+dt],[dtold dt dt])
%
subplot(324);
for i=1:nn
plot([x(i) xc(i)],[t t+dt]);
end
t=t+dt;
plot([xmin xmax],[t t]);
%
subplot(321); hold off; plot(xc,u);title('solution');
hold on
%
dtold=dt;
uold=u;
xold=x;
xcold=xc;
%
if exactflag=='y'
clear uex;
xcopy=x;
for i=1:nn
x=xc(i);
uex(i)=eval(uexact);
end
plot(xc,uex,'g:')
%
uex=(uex(1:nn-1)+uex(2:nn))/2;
U=(u(1:nn-1)+u(2:nn))/2;
h=diff(xc);
err=sqrt(sum(h.*(U-uex).^2));
disp(['exact error = ' num2str(err)]);
end
%
%pause(1)
%
end  %while t<tmax
stability

