function [x,xc,u,dt]=timestep(xold,xcold,uold,t,dtold);
%disp('timestep')
global xmin xmax tmin tmax diffusion convection absorption force
global initialdata bctype kl kr gl gr res spres globerr tol
%
% keep old mesh ? (default)
%
x=xcold;
nn=length(x);
ni=nn-1;
xcopy=x;
dt=min(1.5*dtold,tol*dtold/2/globerr(2));
meshchange='n';
%
% or remesh ? (yes, if t>tmin and error too small or mesh too distorted)
%
% compute percentage of elem with too small errors
%
if t>tmin
h=diff(xold);
locerr=h.*(h.^2.*res).^2;
tresh=0.2*tol^2/ni*ones(size(locerr));
tresh=(tresh-locerr)./(abs(tresh-locerr)+0.0001*ones(size(locerr)));
percent=sum(max(tresh,zeros(size(tresh))))/ni*100;
%
% mesh too distorted ?
%
for i=1:nn;
x=xcopy(i);
u=uold(i);
c(i)=eval(convection);
end
x=xcopy;
h=diff(x);
maxdt=min(h./max(0.0001*ones(size(h)),(-diff(c))))/2;
%
% checking for remeshing
%
if maxdt<dt/2|percent>10
x=timecorr(xold);
nn=length(x);
ni=nn-1;
xcopy=x;
meshchange='y';
end
end
%
h=diff(x);
hh(2:2:2*ni)=h;
hh(1:2:2*ni-1)=h;
xx(1:2:2*ni)=x(1:ni);
xx(2:2:2*ni+1)=x(2:nn);
subplot(323);hold off;plot(xx,hh,'-');hold on;
title('current meshsize h(x)')
%
% start of test loop
%
ok=-1;
run=1;
while ok<0
%
%creating data vectors
%
clear xc d Dd c a f uoldproj r
%
if t==tmin;
for i=1:nn;
x=xcopy(i);
uoldproj(i)=eval(initialdata);
r=zeros(size(1:ni));
end
elseif t>tmin;
if meshchange=='n'
uoldproj=uold;
%r=res;
%r=(r(1:ni)+r(2:nn))/2;
else
j=1;
uoldproj(1)=uold(1);
for i=2:nn;
 x=xcopy(i);
 while xcold(j)<x-eps
  j=j+1;
 end
 w1=(xcold(j)-x)/(xcold(j)-xcold(j-1));
 w2=(x-xcold(j-1))/(xcold(j)-xcold(j-1));
 uoldproj(i)=w1*uold(j-1)+w2*uold(j);
% r(i-1)=res(j-1);
end
%figure(2)
%plot(xold,uold);%hold on;%plot(xcopy,uoldproj);%pause;%hold off
end
end
%
% computing c
%
for i=1:nn;
 u=uoldproj(i);
 x=xcopy(i);
 c(i)=eval(convection);
end
c(1)=0;c(nn)=0;
%
% computing dt
%
h=diff(xcopy);
maxdt=min(h./max(0.0001*ones(size(h)),-diff(c)));
dt=min(dt,maxdt);
%
% computing xc
%
x=xcopy;
xc=x+dt*c;
xc(1)=x(1);
xc(nn)=x(nn);
%
% computing element values of c and uoldproj
%
w=uoldproj;
Dw=diff(uoldproj)./h;
res=max(Dw,ones(size(Dw)));
uoldproj=(uoldproj(1:ni)+uoldproj(2:nn))/2;
cc=(c(1:ni)+c(2:nn))/2;
%
% computing data vectors
%
t=t+dt/2;
%
conv='n';
iter=0;
while conv=='n'
clear d c a f
for i=1:ni;
x=xcopy(i)+h(i)/2+dt*cc(i)/2;
u=(w(i)+w(i+1))/2;
 d(i)=eval(diffusion);
 c(i)=eval(convection)-cc(i);
 a(i)=eval(absorption);
 f(i)=eval(force);
 x=x+0.01*h(i);
 dplus=eval(diffusion);
 Dd(i)=(dplus-d(i))/(0.01*h(i));
% Dd(i)=0;
d(i)=max(max(d(i),h(i)^2*max(max(res(i),Dw(i)),1)),0.2*tol);
end
x=xcopy;
g(1)=eval(gl);g(2)=eval(gr);k(1)=eval(kl);k(2)=eval(kr);
%
%computing stiffness matrix  s  and r.h.s.  b
%
ddt=dt*d;
Dddt=dt*Dd;
cdt=zeros(size(d));
%cdt=dt*c;
o=ones(size(d));
adt=dt*a+o;
kdt=k*dt;
s=stiff2(x,ddt,Dddt,cdt,adt,kdt,bctype);
fdt=dt*f+uoldproj;
b=loads2(x,ddt,Dddt,cdt,adt,fdt,g,bctype,dt);
%
%solving tridiagonal system of equations
%
u=(s\b')';
%
%adding given boundary values
%
if bctype(1)==0
u=[g(1),u];
end
if bctype(2)==0
u=[u,g(2)];
end
%u=u'; %for displaying solution data
%u=u';
%
%[ok,globalerr,res]=test(x,dt,u,uoldproj,res,Dw,d,Dd,c,a,f,tol);
uu=(u(1:ni)+u(2:nn))/2;ww=(w(1:ni)+w(2:nn))/2;
remrelerr=sqrt(sum((uu-ww).^2.*h))/sqrt(sum(ww.^2.*h));
if remrelerr<0.3*tol|iter==10
conv='y';
end
%remerr=max(abs(u-w))/max(w)
disp(['    iteration error = ' num2str(remrelerr)])
if iter==10
disp('  warning, solution not converged')
end
iter=iter+1;
w=u;
Dw=diff(w)./h;
end
%
t=t-dt/2;
%
%testing if solution ok
%
[ok,globerr,res,spres]=timetest(x,dt,u,uoldproj,res,Dw,d,Dd,c,a,f,tol);
%
subplot(325)
xx(2:2:2*ni)=x(2:nn);
xx(1:2:2*ni-1)=x(1:ni);
pres(2:2:2*ni)=res(1:ni);
pres(1:2:2*ni-1)=res(1:ni);
pspres(2:2:2*ni)=spres(1:ni);
pspres(1:2:2*ni-1)=spres(1:ni);
plot(xx,pres);hold on;
plot(xx,pspres,':');title('residuals');hold off;
error=[num2str(globerr(1)) '+' num2str(globerr(2))];
%refining the mesh if error too large
%
if ok<0
disp(['  estim error too large = ' error])
disp('  refining the mesh')
%
if globerr(1)>tol/2
res=res*(0.8+0.2*run);
spres=spres*(0.8+0.2*run);
%spres=diag(h)/3\spres';
%hinv=h.^(-ones(size(h)));
%z=zeros(size(h));
%diffus=spdiags([-hinv' 2*hinv' -hinv'],-1:1,ni,ni);
%spres=(diag(h)/3+tol^4*diffus)\spres;
%spres=spres';
spres(2:ni-1)=spres(1:ni-2)/6+2*spres(2:ni-1)/3+spres(3:ni)/6;
x=timecorr(x);
nn=length(x);ni=nn-1;xcopy=x;
meshchange='y';
h=diff(x);
xx(1:2:2*ni)=x(1:ni);
xx(2:2:2*ni+1)=x(2:nn);
hh(1:2:2*ni-1)=h;
hh(2:2:2*ni)=h;
subplot(323);plot(xx,hh,':');title('new meshsize h(x)');
end
globerr(2)=globerr(2)*(0.9+0.1*run);
dt=min(1.5*dtold,tol*dt/2/globerr(2));
%dt=0.0001;
%nn
%dt
%pause(1)
run=run+1;
%
%accepting current solution if error ok
%
elseif ok>0
disp(['  estim error = ' error ' OK']);
%
end %test loop
end %main loop





